/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2015 - 2022 Steffen Hupp, Torsten Lenhart, Balthasar Weitzel, Stefan Schweitzer, Benjamin Hassenfratz
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.api.communication.clientmodel;

import java.util.Collection;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import de.fhg.iese.dd.platform.api.participants.person.clientmodel.PersonClientModelMapper;
import de.fhg.iese.dd.platform.api.shared.files.clientmodel.FileClientModelMapper;
import de.fhg.iese.dd.platform.api.shared.usergeneratedcontentflag.clientmodel.UserGeneratedContentFlagClientModelMapper;
import de.fhg.iese.dd.platform.datamanagement.communication.model.Chat;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatMessage;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatParticipant;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatSubject;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;
import de.fhg.iese.dd.platform.datamanagement.shared.usergeneratedcontentflags.model.UserGeneratedContentFlag;

@Component
public class CommunicationClientModelMapper {

    @Autowired
    private PersonClientModelMapper personClientModelMapper;
    @Autowired
    private FileClientModelMapper fileClientModelMapper;
    @Autowired
    private UserGeneratedContentFlagClientModelMapper userGeneratedContentFlagClientModelMapper;

    //if we do not have a last message we just put it to the end of the list
    //actually empty chats should never happen, so this case is more hypothetical
    private static final Comparator<ClientChat> SORT_CLIENT_CHAT_BY_LAST_MESSAGE_CREATED_DESC =
            Comparator
                    .comparingLong((ClientChat c) -> c.getLastMessage() != null ? c.getLastMessage().getCreated() :
                            Long.MIN_VALUE)
                    .reversed();

    public ClientChatMessage toClientChatMessage(ChatMessage chatMessage) {
        if (chatMessage == null) {
            return null;
        }
        ClientChatMessage clientChatMessage = ClientChatMessage.builder()
                .id(chatMessage.getId())
                .chatId(chatMessage.getChat().getId())
                .message(chatMessage.getMessage())
                .mediaItem(fileClientModelMapper.toClientMediaItem(chatMessage.getMediaItem()))
                .sentTime(chatMessage.getSentTime())
                .created(chatMessage.getCreated())
                .autoGenerated(chatMessage.isAutoGenerated())
                .referencedEntityName(chatMessage.getReferencedEntityName())
                .referencedEntityId(chatMessage.getReferencedEntityId())
                .build();

        if (chatMessage.getSender() != null) {
            clientChatMessage.setSenderId(chatMessage.getSender().getId());
            clientChatMessage.setSenderFirstName(chatMessage.getSender().getFirstName());
            clientChatMessage.setSenderLastName(chatMessage.getSender().getLastName());
        }
        return clientChatMessage;
    }

    public List<ClientChat> toClientChats(Collection<Chat> chats, Person requester) {
        return chats.stream()
                .map(c -> toClientChat(c, requester))
                .sorted(SORT_CLIENT_CHAT_BY_LAST_MESSAGE_CREATED_DESC)
                .collect(Collectors.toList());
    }

    public ClientChat toClientChat(final Chat chat, Person requester) {
        if (chat == null) {
            return null;
        }

        return convertChat(chat, new ClientChat(), requester);
    }

    public ClientUserGeneratedContentFlagChat toClientUserGeneratedContentFlagChat(
            final UserGeneratedContentFlag userGeneratedContentFlag, final Chat flaggedChat,
            final long numberOfChatMessages) {
        ClientUserGeneratedContentFlagChat clientFlagChat = ClientUserGeneratedContentFlagChat.builder()
                .chatParticipants(flaggedChat.getParticipants().stream()
                        .map(ChatParticipant::getPerson)
                        .map(personClientModelMapper::createClientPersonReference)
                        .collect(Collectors.toList()))
                .topic(flaggedChat.getTopic())
                .createdTimestamp(flaggedChat.getCreated())
                .lastMessageTimestamp(flaggedChat.getLastMessageNotAutoGenerated().getSentTime())
                .numberOfChatMessages(numberOfChatMessages)
                .build();
        return userGeneratedContentFlagClientModelMapper.setClientUserGeneratedContentFlagDetailAttributes(
                userGeneratedContentFlag,
                clientFlagChat);
    }

    private ClientChatParticipant createClientChatParticipant(final ChatParticipant chatParticipant) {
        return ClientChatParticipant.builder()
                .id(chatParticipant.getId())
                .person(personClientModelMapper.createClientPersonReference(chatParticipant.getPerson()))
                .receivedTime(chatParticipant.getReceivedTime())
                .readTime(chatParticipant.getReadTime())
                .build();
    }

    public List<ClientChatExtended> createClientChatsExtended(Collection<Chat> chats, Person requester) {
        return chats.stream()
                .map(c -> createClientChatExtended(c, requester))
                .sorted(SORT_CLIENT_CHAT_BY_LAST_MESSAGE_CREATED_DESC)
                .collect(Collectors.toList());
    }

    private ClientChatExtended createClientChatExtended(final Chat chat, Person requester) {
        if (chat == null) {
            return null;
        }
        ClientChatExtended clientChatExtended = new ClientChatExtended();

        convertChat(chat, clientChatExtended, requester);

        clientChatExtended.setSubjects(chat.getSubjects().stream()
                .map(this::createClientChatSubject)
                .collect(Collectors.toList()));

        return clientChatExtended;
    }

    private ClientChat convertChat(Chat from, ClientChat to, Person requester){

        to.setChatParticipants(from.getParticipants().stream()
                        .map(this::createClientChatParticipant)
                        //sorting is not really relevant, just to ensure that it is always the same order
                        .sorted(Comparator.comparing(
                                clientChatParticipant -> clientChatParticipant.getPerson().getId()))
                        .collect(Collectors.toList()));
        to.setLastMessage(toClientChatMessage(from.getLastMessageNotAutoGenerated()));
        to.setChatTopic(from.getTopic());

        //the requester should always be part of the participants, it's checked before
        from.getParticipants().stream()
                .filter(cp -> requester.equals(cp.getPerson()))
                .findAny()
                //if unread message count is null it has the semantic of 0
                .ifPresent(participant -> to.setUnreadMessageCount(
                        participant.getUnreadMessageCount() == null ? 0 : participant.getUnreadMessageCount()));
        to.setId(from.getId());
        return to;
    }

    private ClientChatSubject createClientChatSubject(final ChatSubject chatSubject) {
        return ClientChatSubject.builder()
                .entityId(chatSubject.getEntityId())
                .entityName(chatSubject.getEntityName()).build();
    }

}
